;CFC_ATTR

; ------------------------------------------
; Changer le facteur d'extension d'attribut
; ------------------------------------------


; Fichier info: CFC_ATTR.TXT



(defun c:cfc_attr ()

;;; On slectionne un attribut pour retrouver le nom du bloc

(setq attr (car (entsel "\nCliquez sur un attribut")))
                
(if (and 
        (= (cdr (assoc 0 (entget attr))) "INSERT")
        (= (cdr (assoc 66 (entget attr))) 1)
        )
(progn                

        (setq b (cdr (assoc 2 (entget attr))))

;;; On cre un jeu de slection contenant tous les blocs avec attributs
;;; ou on ne modifie que celui slectionn

(setq jeu nil)

(initget 7 "T U")
(setq choix (getkword "\nModification Totale ou Unique T/U: "))

(if (= choix "T")
(setq jeu (ssget "x" (list (cons 0 "insert")(cons 2 b))))
(progn
(setq jeu (ssadd))
(ssadd attr jeu)
)
)

(setq nb (sslength jeu))

(princ "\nIl y a ") (princ nb) (princ " blocs trouvs.") 

;;; On dfinit le nouveau facteur d'extension ou de compression
(initget (+ 1 2 4))
(setq nht (getreal "\nNouveau facteur d'extension ou de compression du texte: "))

(princ "\nPatience...travail en cours.")

(setq compte 0)

;;; On cre une boucle tant qu'il y a de blocs 

(repeat nb
    (setq bl (ssname jeu compte))
    (extat) ;;; module de rcupration des infos des attributs
    (setq compte (+ 1 compte))
) ;fin de boucle


;;; On provoque une rgnration du dessin

(command "regen")
(princ "\nFIN DU TRAVAIL...")
(princ)
                
) ; fin du progn

(princ "\nL'entit slectionne n'est pas un attribut !!")
        
) ;fin du if

(princ)

) ; fin du defun du programme principal CHATTR

;;; ---------------------------------------------------
;;; MODULE DE RECUPERATION DES INFOS DANS LES ATTRIBUTS
;;; ---------------------------------------------------


(defun extat ()

(setq att (entnext bl))

(setq cle_0 (cdr (assoc 0 (entget att))))
        
;;; On fait tant que la valeur de la cl 0 est diffrente de SEQEND

(while (/= cle_0 "SEQEND")

;;; On rcupre le facteur  contenu dans la cl 41

(setq cle_41  (assoc 41 (entget att)))

;;; On cre une nouvelle cl 41 contenant le nouveau facteur
(setq ncle_41 (cons 41 nht)) 

;;; On modifie la base de donne de l'attribut

(setq natt (subst ncle_41 cle_41 (entget att)))

;;; On met  jour la base de donnes

(entmod natt)                              

;;; On rcupre le code entit du prochain attribut

(setq att (entnext att))

;;; On rcupre la valeur de sa cl 0

(setq cle_0 (cdr (assoc 0 (entget att)))) 
        
) ; fin du while                               

) ; fin du defun module EXTAT                                       

;;; Message affich lors du chargement du programme CFC_ATTR.LSP

(princ "\n==> CFC_ATTR")
(princ)
